//+------------------------------------------------------------------+
//|                                                    SimpleBars.mq4|
//|                                                  excelf@gmail.com|
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Ivan Kornilov. All rights reserved."
#property link "excelf@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Green
#property indicator_maximum 1
#property indicator_minimum 0

#define SIGNAL_NONE        0// 
#define SIGNAL_BUY         1//   
#define SIGNAL_SELL       -1//   
#define SIGNAL_TRADE_ALLOW 3//  


extern string TimeFrame  = "Current time frame";
extern int    period = 6;
extern bool   useClose = true;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern bool   ShowArrows            = true;
extern string arrowsIdentifier      = "sbars Arrows1";
extern double arrowsUpperGap        = 0.5;
extern double arrowsLowerGap        = 0.5;
extern color  arrowsUpColor         = LimeGreen;
extern color  arrowsDnColor         = Red;
extern int    arrowsUpCode          = 225;
extern int    arrowsDnCode          = 226;
extern int    arrowsUpSize          = 2;
extern int    arrowsDnSize          = 2;

extern int width = 2;


double bufferRed1[];
double bufferGreen1[];
double bufferRed2[];
double bufferGreen2[];
double trand[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

int init() {
    IndicatorBuffers(5);
 
    SetIndexBuffer(0, bufferRed1);
    SetIndexBuffer(1, bufferGreen1);
    SetIndexBuffer(2, bufferRed2);
    SetIndexBuffer(3, bufferGreen2);
    SetIndexBuffer(4, trand);
    
    IndicatorDigits(Digits+1);
    SetIndexStyle(0, DRAW_HISTOGRAM, 0, width);
    SetIndexStyle(1, DRAW_HISTOGRAM, 0, width);
      indicatorFileName = WindowExpertName();
      returnBars     = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame      = stringToTimeFrame(TimeFrame); 
return(0);
}
int deinit() 
{  
   deleteArrows(); 
return(0); 
}


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(1-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { bufferRed1[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
   for(int i = limit - 1; i >= 0; i--) 
   {
        if(useClose) {
            double buyPrice = Close[i];
            double sellPrice = Close[i];
        } else {
            buyPrice = Low[i];
            sellPrice = High[i];
        }
        if(trand[i + 1] == SIGNAL_NONE || trand[i + 1] == EMPTY_VALUE) {
            if(Close[i] > Open[i]) {
               trand[i] = SIGNAL_BUY;
           } else {
               trand[i] = SIGNAL_SELL;
           }
        } else {
            if(trand[i + 1] == SIGNAL_BUY) {
                if(buyPrice > Low[i + 1]) {
                   trand[i] = SIGNAL_BUY;
                } else {
                   for(int j = 2; j <= period; j++) {
                        if(buyPrice > Low[i + j]) {
                           trand[i] = SIGNAL_BUY;
                        break;
                        } else {
                           trand[i] = SIGNAL_SELL;
                        }
                   }
                }
            } else if(trand[i + 1] == SIGNAL_SELL) {
                if(sellPrice < High[i + 1]) {
                   trand[i] = SIGNAL_SELL;
                } else {
                    for(j = 2; j <= period; j++) {
                        if(sellPrice < High[i + j]) {
                           trand[i] = SIGNAL_SELL;
                           break;
                        } else {
                           trand[i] = SIGNAL_BUY;
                        }
                   }
                }
            }   
        }

         bufferRed1[i]   = EMPTY_VALUE;
         bufferGreen1[i] = EMPTY_VALUE;
        if(trand[i] == SIGNAL_SELL) bufferRed1[i] = 1;
        if(trand[i] == SIGNAL_BUY)  bufferGreen1[i] = 1;
        
        //
        //
        //
        //
        //
                  
        if (ShowArrows)
        {
           deleteArrow(Time[i]);
           if (trand[i]!=trand[i+1])
           {
              if (trand[i] ==SIGNAL_SELL) drawArrow(i,arrowsDnColor,arrowsDnCode,arrowsDnSize,true);
              if (trand[i] ==SIGNAL_BUY ) drawArrow(i,arrowsUpColor,arrowsUpCode,arrowsUpSize,false);
           }
        }              
    }
    manageAlerts();
    return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i = limit; i >= 0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      trand[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",period,useClose,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,ShowArrows,arrowsIdentifier,arrowsUpperGap,arrowsLowerGap,arrowsUpColor,arrowsDnColor,arrowsUpCode,arrowsDnCode,arrowsUpSize,arrowsDnSize,4,y);
      bufferRed1[i]   = EMPTY_VALUE;
      bufferGreen1[i] = EMPTY_VALUE;
      if(trand[i] == SIGNAL_SELL) bufferRed1[i]   = 1;
      if(trand[i] == SIGNAL_BUY)  bufferGreen1[i] = 1; 
   }
   return(0);
       
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trand[whichBar] != trand[whichBar+1])
      {
         if (trand[whichBar] ==SIGNAL_BUY ) doAlert(whichBar,"signal buy");
         if (trand[whichBar] ==SIGNAL_SELL) doAlert(whichBar,"signal sell");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(timeFrameToString(Period())+" "+Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Simple bars ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Simple bars " +" "+message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Simple bars "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,int theWidth,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 3.0*iATR(NULL,0,20,i)/4.0;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_WIDTH,theWidth);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i]+ arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i] - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}





